//************************************************************
//  University of Patras
//      Department of Electrical Engineering & Computer Technology
//
//      Course: Parallel Programming in AI
//      Week 09: OpenAcc
//
//  Description: change Temperature in a plate
//      Author: Evangelos Dermatas
//      v0.1

/*
*********************************************************************
gcc -v: gcc version 9.2.1 (Ubuntu 7.4.0-1ubuntu1~18.04.1)
OS:     Linux Ubuntu 19.10
CPU:    8-core, Intel(R) Core(TM) i7-2630QM CPU @ 2.00GHz, 3991 BogoMips
*********************************************************************
Compiling:   g++ accTempChang01.cpp -o accTempChang01 -O3 -fopenacc -foffload=nvptx-none  -fopt-info
Executing:   time ./accTempCahng01

Output in my Laptop
Sum=1.43237e+06

real	0m16.053s
user	0m16.032s
sys	0m0.022s

*********************************************************************
gcc -v: gcc version 9.2.1 (Ubuntu 7.4.0-1ubuntu1~18.04.1)
OS:     Linux Ubuntu 19.10

Compiling:
pgc++ -std=c++11 -acc -ta=multicore,tesla -Minfo=accel accFill_ex1.cpp -o accFill_ex1

Output in my Laptop




*/


// ***************************************************************
#include <iostream>
#include <cstdlib>
// ***************************************************************

using namespace std;

#define N	1000
#define M	1000

float A[N][M] ;
float B[N][M] ;

// ***************************************************************
void initTemp(void)
{

float t = rand()%100 - 50 ;
for( int i = 0 ; i < N ; i++ )
        A[i][0] = t ;
for( int i = 0 ; i < N ; i++ )
        B[i][0] = t ;

t = rand()%100 - 50 ;
for( int i = 0 ; i < N ; i++ )
        A[i][M-1] = t ;
for( int i = 0 ; i < N ; i++ )
        B[i][M-1] = t ;

t = rand()%100 - 50 ;
for( int j = 0 ; j < M ; j++ )
        A[0][j] = t ;
for( int j = 0 ; j < M ; j++ )
        B[0][j] = t ;

t = rand()%100 - 50 ;
for( int j = 0 ; j < M ; j++ )
        A[N-1][j] = t ;
for( int j = 0 ; j < M ; j++ )
        B[N-1][j] = t ;

t = rand()%100 - 50 ;
for( int i = 1 ; i < N-1 ; i++ )
for( int j = 1 ; j < M-1 ; j++ )
        A[0][j] = t ;
}


// ***************************************************************
float computeTemp( int Time )
{

#pragma acc data create(B[0:N][0:M]) copyin(A[0:N][0:M])
{

for(int k = 0 ; k< Time ; k++ )
{
#pragma acc parallel loop collapse(2) present(B[0:N][0:M],A[0:N][0:M])
for( int i = 1 ; i < N-1 ; i++ )
for( int j = 1 ; j < M-1 ; j++ )
	B[i][j] = (A[i-1][j]+A[i+1][j]+A[i][j-1]+A[i][j+1]+2*A[i][j])/6.0 ;

#pragma acc parallel loop collapse(2) present(B[0:N][0:M],A[0:N][0:M])
for( int i = 1 ; i < N-1 ; i++ )
for( int j = 1 ; j < M-1 ; j++ )
	A[i][j] = (B[i-1][j]+B[i+1][j]+B[i][j-1]+B[i][j+1]+2*B[i][j])/6.0 ;
}
}

float sum = 0 ;

#pragma acc parallel loop collapse(2) reduction(+:sum) present(B[0:N][0:M],A[0:N][0:M])
for( int i = 0 ; i < N ; i++ )
for( int j = 0 ; j < M ; j++ )
	sum +=A[i][j];

return sum ;
}


// ***************************************************************
int main(int argc, char *argv[])
{
float t ;

initTemp() ;
t = computeTemp(1000) ;
cout << "Sum=" << t << endl ;
   return 0;
}
