//************************************************************
//  University of Patras
//      Department of Electrical Engineering & Computer Technology
//
//      Course: Parallel Programming in AI
//      Week 09: OpenAcc
//
//  Description: change Temperature in a plate
//      Author: Evangelos Dermatas
//      v0.1

/*
*********************************************************************
gcc -v: gcc version 9.2.1 (Ubuntu 7.4.0-1ubuntu1~18.04.1)
OS:     Linux Ubuntu 19.10
CPU:    8-core, Intel(R) Core(TM) i7-2630QM CPU @ 2.00GHz, 3991 BogoMips
*********************************************************************
Compiling:   g++ tempChang01.cpp -o tempChang01 -O2 

Executing:   time ./tempCahng01

Output in my Laptop
Sum=1.43237e+06

real	0m13.659s
user	0m13.651s
sys		0m0.008s

**********************************************************************
Vector Processing....
Compiling:   g++ tempChang01.cpp -o tempChang01 -O3

Executing:   time ./tempCahng01

Output in my Laptop
Sum=1.43237e+06

real	0m3.882s
user	0m3.870s
sys		0m0.012s

*/


// ***************************************************************
#include <iostream>
#include <cstdlib>
#include <cassert>
// ***************************************************************

using namespace std;

#define N	1000
#define M	1000

float A[N][M] ;
float B[N][M] ;

// ***************************************************************
void initTemp(void)
{

float t = rand()%100 - 50 ;
for( int i = 0 ; i < N ; i++ )
        A[i][0] = t ;
for( int i = 0 ; i < N ; i++ )
        B[i][0] = t ;

t = rand()%100 - 50 ;
for( int i = 0 ; i < N ; i++ )
        A[i][M-1] = t ;
for( int i = 0 ; i < N ; i++ )
        B[i][M-1] = t ;

t = rand()%100 - 50 ;
for( int j = 0 ; j < M ; j++ )
        A[0][j] = t ;
for( int j = 0 ; j < M ; j++ )
        B[0][j] = t ;

t = rand()%100 - 50 ;
for( int j = 0 ; j < M ; j++ )
        A[N-1][j] = t ;
for( int j = 0 ; j < M ; j++ )
        B[N-1][j] = t ;

t = rand()%100 - 50 ;
for( int i = 1 ; i < N-1 ; i++ )
for( int j = 1 ; j < M-1 ; j++ )
        A[0][j] = t ;
}


// ***************************************************************
float computeTemp( int Time )
{

for(int k = 0 ; k< Time ; k++ )
{
for( int i = 1 ; i < N-1 ; i++ )
for( int j = 1 ; j < M-1 ; j++ )
	B[i][j] = (A[i-1][j]+A[i+1][j]+A[i][j-1]+A[i][j+1]+2*A[i][j])/6.0 ;

for( int i = 1 ; i < N-1 ; i++ )
for( int j = 1 ; j < M-1 ; j++ )
	A[i][j] = (B[i-1][j]+B[i+1][j]+B[i][j-1]+B[i][j+1]+2*B[i][j])/6.0 ;
}

float sum = 0 ;
for( int i = 0 ; i < N ; i++ )
for( int j = 0 ; j < M ; j++ )
	sum +=A[i][j];

return sum ;
}


// ***************************************************************
int main(int argc, char *argv[])
{
float t ;

initTemp() ;
t = computeTemp(1000) ;
cout << "Sum=" << t << endl ;
   return 0;
}
